.386
.model flat,stdcall
option casemap:none

include		\masm32\include\windows.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\masm32.inc
includelib		\masm32\lib\kernel32.lib
includelib		\masm32\lib\user32.lib
includelib		\masm32\lib\masm32.lib

.data
template1	db '%s',13,10,0
template2	db '%s PROTO C :VARARG',13,10,0
template3	db 'LIBRARY %s',13,10,'EXPORTS',13,10,13,10,0
message1	db 'DLL to include & def file converter V1.0',13,10
		db 'usage : dll2inc.dll',0
message2	db 'Dll2inc cannot load the requested DLL',0
.data?
temp		db 512 dup(?)
cmdlineparam	db 128 dup(?)
buffer		dd ?
NameNumb	dd ?
hDef		dd ?
hInc		dd ?
size1		dd ?
size2		dd ?
hLib		dd ?
dot		dd ?

.code

start:
        invoke ArgClC,1,ADDR cmdlineparam
        mov al,byte ptr [cmdlineparam]
        or al,al
        jnz @f
        push OFFSET message1
errmsg:
        call StdOut
        jmp finish2
@@:
        invoke LoadLibrary,ADDR cmdlineparam
        or eax,eax
        jnz @f
        push OFFSET message2
        jmp errmsg
@@:
        push esi
        push edi
        mov hLib,eax
        mov edi,eax
        assume edi:ptr IMAGE_DOS_HEADER
        add edi,[edi].e_lfanew
        assume edi:ptr IMAGE_NT_HEADERS
        mov edi,[edi].OptionalHeader.DataDirectory.VirtualAddress
        add edi,eax
        assume edi:ptr IMAGE_EXPORT_DIRECTORY
        push [edi].NumberOfNames
        pop NameNumb
        mov esi,[edi].AddressOfNames
        add esi,eax
        mov buffer,esi
        mov esi,OFFSET cmdlineparam
@@:
        mov al,[esi]
        or al,al
        jz finish1
        cmp al,'.'
        je @f
        inc esi
        jmp @b
@@:
        inc esi
        mov dot,esi
        mov dword ptr [esi],'fed'
        call crtfile
        mov hDef,eax
        mov dword ptr [esi],'cni'
        call crtfile
        mov hInc,eax
        mov byte ptr [esi-1],0
        invoke wsprintf,ADDR temp,ADDR template3,ADDR cmdlineparam
        invoke StrLen,ADDR temp
        invoke WriteFile,hDef,ADDR temp,eax,ADDR size1,0
        mov esi,buffer
        .WHILE NameNumb>0
                mov edi,[esi]
                add edi,hLib
                cmp byte ptr [edi],'?'
                je @f
                invoke wsprintf,ADDR temp,ADDR template1,edi,edi
                invoke WriteFile,hDef,ADDR temp,eax,ADDR size1,0
                invoke wsprintf,ADDR temp,ADDR template2,edi
                invoke WriteFile,hInc,ADDR temp,eax,ADDR size2,0
                @@:
                dec NameNumb
                add esi,4
        .ENDW
        invoke FreeLibrary,hLib
        invoke CloseHandle,hDef
        invoke CloseHandle,hInc
finish1:
        pop edi
        pop esi 
finish2:
        invoke ExitProcess,0

crtfile PROC
        invoke CreateFile,ADDR cmdlineparam,GENERIC_WRITE,\
               0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
        ret
crtfile ENDP
end start
